# Parameters related to the Behavior Tree (BT) navigator
bt_navigator:
  ros__parameters:
    use_sim_time: True # Whether to use the simulation time or not (on the simulated robot, this should be True)
    global_frame: map
    robot_base_frame: base_footprint
    odom_topic: /odom
    bt_loop_duration: 10
    default_server_timeout: 20
    # 'default_nav_through_poses_bt_xml' and 'default_nav_to_pose_bt_xml' are use defaults:
    # nav2_bt_navigator/navigate_to_pose_w_replanning_and_recovery.xml
    # nav2_bt_navigator/navigate_through_poses_w_replanning_and_recovery.xml
    # They can be set here or via a RewrittenYaml remap from a parent launch file to Nav2.
    plugin_lib_names:
    - nav2_compute_path_to_pose_action_bt_node
    - nav2_compute_path_through_poses_action_bt_node
    - nav2_smooth_path_action_bt_node
    - nav2_follow_path_action_bt_node
    - nav2_spin_action_bt_node
    - nav2_wait_action_bt_node
    - nav2_assisted_teleop_action_bt_node
    - nav2_back_up_action_bt_node
    - nav2_drive_on_heading_bt_node
    - nav2_clear_costmap_service_bt_node
    - nav2_is_stuck_condition_bt_node
    - nav2_goal_reached_condition_bt_node
    - nav2_goal_updated_condition_bt_node
    - nav2_globally_updated_goal_condition_bt_node
    - nav2_is_path_valid_condition_bt_node
    - nav2_initial_pose_received_condition_bt_node
    - nav2_reinitialize_global_localization_service_bt_node
    - nav2_rate_controller_bt_node
    - nav2_distance_controller_bt_node
    - nav2_speed_controller_bt_node
    - nav2_truncate_path_action_bt_node
    - nav2_truncate_path_local_action_bt_node
    - nav2_goal_updater_node_bt_node
    - nav2_recovery_node_bt_node
    - nav2_pipeline_sequence_bt_node
    - nav2_round_robin_node_bt_node
    - nav2_transform_available_condition_bt_node
    - nav2_time_expired_condition_bt_node
    - nav2_path_expiring_timer_condition
    - nav2_distance_traveled_condition_bt_node
    - nav2_single_trigger_bt_node
    - nav2_goal_updated_controller_bt_node
    - nav2_is_battery_low_condition_bt_node
    - nav2_navigate_through_poses_action_bt_node
    - nav2_navigate_to_pose_action_bt_node
    - nav2_remove_passed_goals_action_bt_node
    - nav2_planner_selector_bt_node
    - nav2_controller_selector_bt_node
    - nav2_goal_checker_selector_bt_node
    - nav2_controller_cancel_bt_node
    - nav2_path_longer_on_approach_bt_node
    - nav2_wait_cancel_bt_node
    - nav2_spin_cancel_bt_node
    - nav2_back_up_cancel_bt_node
    - nav2_assisted_teleop_cancel_bt_node
    - nav2_drive_on_heading_cancel_bt_node

bt_navigator_navigate_through_poses_rclcpp_node:
  ros__parameters:
    use_sim_time: True # Whether to use the simulation time or not (on the simulated robot, this should be True)

bt_navigator_navigate_to_pose_rclcpp_node:
  ros__parameters:
    use_sim_time: True # Whether to use the simulation time or not (on the simulated robot, this should be True)

# Parameters related to the controller server
controller_server:
  ros__parameters:
    use_sim_time: True # Whether to use the simulation time or not (on the simulated robot, this should be True)
    controller_frequency: 20.0
    min_x_velocity_threshold: 0.001
    min_y_velocity_threshold: 0.001
    min_theta_velocity_threshold: 0.001
    failure_tolerance: 0.5
    progress_checker_plugin: "progress_checker"
    goal_checker_plugins: ["general_goal_checker"]
    controller_plugins: ["FollowPath"]

    # Progress checker parameters
    progress_checker:
      plugin: "nav2_controller::SimpleProgressChecker"
      required_movement_radius: 0.5
      movement_time_allowance: 10.0
    # Goal checker parameters
    general_goal_checker:
      stateful: True
      plugin: "nav2_controller::SimpleGoalChecker"
      xy_goal_tolerance: 0.25
      yaw_goal_tolerance: 0.25
    FollowPath:
      plugin: "nav2_rotation_shim_controller::RotationShimController"
      primary_controller: "nav2_regulated_pure_pursuit_controller::RegulatedPurePursuitController"
      angular_dist_threshold: 0.785
      forward_sampling_distance: 0.5
      rotate_to_heading_angular_vel: 1.8
      max_angular_accel: 3.2
      simulate_ahead_time: 1.0
      rotate_to_goal_heading: false

    # # DWB parameters
    # FollowPath:
    #   plugin: "dwb_core::DWBLocalPlanner" # Name of the plugin to use for planning (in this case, DWBLocalPlanner)
    #   debug_trajectory_details: False
    #   min_vel_x: 0.0
    #   min_vel_y: 0.0
    #   max_vel_x: 0.4
    #   max_vel_y: 0.0
    #   max_vel_theta: 1.0
    #   min_speed_xy: 0.0
    #   max_speed_xy: 0.0
    #   min_speed_theta: 0.0
    #   acc_lim_x: 1.0
    #   acc_lim_y: 0.0
    #   acc_lim_theta: 0.5
    #   decel_lim_x: -1.0
    #   decel_lim_y: 0.0
    #   decel_lim_theta: -0.5
    #   vx_samples: 20
    #   vy_samples: 5
    #   vtheta_samples: 20
    #   sim_time: 1.7
    #   linear_granularity: 0.05
    #   angular_granularity: 0.025
    #   transform_tolerance: 0.2
    #   xy_goal_tolerance: 0.25
    #   trans_stopped_velocity: 0.25
    #   short_circuit_trajectory_evaluation: True
    #   stateful: True
    #   critics: ["RotateToGoal", "Oscillation", "BaseObstacle", "GoalAlign", "PathAlign", "PathDist", "GoalDist"] # List of critics to use for scoring trajectories
    #   # Parameters related to the various critics
    #   BaseObstacle.scale: 0.02
    #   PathAlign.scale: 32.0
    #   PathAlign.forward_point_distance: 0.1
    #   GoalAlign.scale: 24.0
    #   GoalAlign.forward_point_distance: 0.1
    #   PathDist.scale: 32.0
    #   GoalDist.scale: 24.0
    #   RotateToGoal.scale: 32.0
    #   RotateToGoal.slowing_factor: 5.0
    #   RotateToGoal.lookahead_time: -1.0

# Parameters related to the local costmap
local_costmap:
  local_costmap:
    ros__parameters:
      update_frequency: 10.0 # Frequency at which the costmap is updated (typically higher than the global costmap)
      publish_frequency: 4
      global_frame: odom
      robot_base_frame: base_footprint
      use_sim_time: True # Whether to use the simulation time or not (on the simulated robot, this should be True)
      rolling_window: true
      width: 4 # Size of the local costmap in meters
      height: 4 # Size of the local costmap in meters
      resolution: 0.03 # Resolution of the local costmap    robot_radius: 0.3 # Radius of the robot
      footprint: '[[0.0, 0.3], [0.21, 0.21], [0.28, 0.1],[0.4, 0.1] [0.4, -0.1], [0.28, -0.1],   [0.21, -0.21], [0.0, -0.3],[-0.21, -0.21], [-0.28, -0.1],[-0.4, -0.1] [-0.4, 0.1], [-0.28, 0.1],   [-0.21, 0.21]]'
      plugins: ["voxel_layer", "inflation_layer", "obstacle_layer"]
      inflation_layer:
        plugin: "nav2_costmap_2d::InflationLayer"
        cost_scaling_factor: 1.3 # Indicates how the gradient in cost values around obstacles decay with distance from the obstacle
        inflation_radius: 0.15 # Radius used for inflating the obstacles
      voxel_layer:
        plugin: "nav2_costmap_2d::VoxelLayer"
        enabled: True
        publish_voxel_map: True
        origin_z: 0.0
        z_resolution: 0.03
        z_voxels: 16
        max_obstacle_height: 2.0
        mark_threshold: 0
        observation_sources: scan
        # Parameters related to the laser scan
        scan:
          topic: /scan
          max_obstacle_height: 2.0
          clearing: True
          marking: True
          data_type: "LaserScan"
          raytrace_max_range: 3.0
          raytrace_min_range: 0.1
          obstacle_max_range: 2.5
          obstacle_min_range: 0.0
      obstacle_layer:
        plugin: "nav2_costmap_2d::ObstacleLayer"
        enabled: True
        observation_sources: scan
        #inf_is_valid: True
        # Parameters related to the laser scan
        scan:
          topic: /scan
          max_obstacle_height: 2.0
          clearing: True
          marking: True
          data_type: "LaserScan"
          raytrace_max_range: 3.0
          raytrace_min_range: 0.1
          obstacle_max_range: 2.5
          obstacle_min_range: 0.0
      static_layer:
        plugin: "nav2_costmap_2d::StaticLayer"
        map_subscribe_transient_local: True
      always_send_full_costmap: True

# Parameters related to the global costmap
global_costmap:
  global_costmap:
    ros__parameters:
      update_frequency: 1.0 # 2.054 # Frequency at which the costmap is updated (typically lower than the local costmap)
      publish_frequency: 1.0
      global_frame: map
      robot_base_frame: base_footprint
      use_sim_time: True # Whether to use the simulation time or not (on the simulated robot, this should be True)
      robot_radius: 0.3 # Radius of the robot
      resolution: 0.03 # Resolution of the global costmap
      track_unknown_space: True
      plugins: ["obstacle_layer", "static_layer", "inflation_layer"]
      obstacle_layer:
        plugin: "nav2_costmap_2d::ObstacleLayer"
        enabled: True
        observation_sources: scan
        # Parameters related to the laser scan
        scan:
          topic: /scan
          max_obstacle_height: 2.0
          clearing: True
          marking: False
          data_type: "LaserScan"
          raytrace_max_range: 3.0
          raytrace_min_range: 0.1
          obstacle_max_range: 2.5
          obstacle_min_range: 0.0
      static_layer:
        plugin: "nav2_costmap_2d::StaticLayer"
        enabled: True
        map_subscribe_transient_local: True
        footprint_clearing_enabled: True
        subscribe_to_updates: True
        # map_topic: map
      inflation_layer:
        plugin: "nav2_costmap_2d::InflationLayer"
        enabled: True
        cost_scaling_factor: 1.3 # Indicates how the gradient in cost values around obstacles decay with distance from the obstacle
        inflation_radius: 0.2 # Radius used for inflating the obstacles
      always_send_full_costmap: True #True

# Parameters related to the map server
map_server:
  ros__parameters:
    use_sim_time: True # Whether tLaserScano use the simulation time or not (on the simulated robot, this should be True)
    # Overridden in launch by the "map" launch configuration or provided default value.
    # To use in yaml, remove the default "map" value in the tb3_simulation_launch.py file & provide full path to map below.
    yaml_filename: "/home/robocup/ros2_ws/src/nav2_bringup/map/areana_b.yaml"
    # yaml_filename: ""

# Parameters related to the map saver
map_saver:
  ros__parameters:
    use_sim_time: True # Whether to use the simulation time or not (on the simulated robot, this should be True)
    save_map_timeout: 5.0
    free_thresh_default: 0.25
    occupied_thresh_default: 0.65
    map_subscribe_transient_local: True

# Parameters related to the planner server
planner_server:
  ros__parameters:
    expected_planner_frequency: 20.0
    use_sim_time: True # Whether to use the simulation time or not (on the simulated robot, this should be True)
    planner_plugins: ["GridBased"]
    GridBased:
      plugin: "nav2_navfn_planner/NavfnPlanner" # Name of the plugin to use for planning (in this case, NavfnPlanner)
      tolerance: 1.0
      use_astar: false # Whether or not to use the A* heuristic (if false, Dijkstra's algorithm is used)
      allow_unknown: true # Whether or not to allow paths through unknown space

# Parameters related to the smoother server
smoother_server:
  ros__parameters:
    use_sim_time: True # Whether to use the simulation time or not (on the simulated robot, this should be True)
    smoother_plugins: ["simple_smoother"]
    simple_smoother:
      plugin: "nav2_smoother::SimpleSmoother"
      tolerance: 1.0e-10
      max_its: 1000
      do_refinement: True

# Parameters related to the behavior server
behavior_server:
  ros__parameters:
    costmap_topic: local_costmap/costmap_raw
    footprint_topic: local_costmap/published_footprint
    cycle_frequency: 10.0
    behavior_plugins: ["spin", "backup", "drive_on_heading", "assisted_teleop", "wait"] # List of plugins to use for behaviors of the robot
    # Plugins for the behaviors
    spin:
      plugin: "nav2_behaviors/Spin"
    backup:
      plugin: "nav2_behaviors/BackUp"
    drive_on_heading:
      plugin: "nav2_behaviors/DriveOnHeading"
    wait:
      plugin: "nav2_behaviors/Wait"
    assisted_teleop:
      plugin: "nav2_behaviors/AssistedTeleop"
    global_frame: odom
    robot_base_frame: base_footprint
    transform_tolerance: 0.1
    use_sim_time: true # Whether to use the simulation time or not (on the simulated robot, this should be True)
    simulate_ahead_time: 2.0
    max_rotational_vel: 1.0
    min_rotational_vel: 0.4
    rotational_acc_lim: 3.2

# Parameters related to the robot state publisher
robot_state_publisher:
  ros__parameters:
    use_sim_time: True # Whether to use the simulation time or not (on the simulated robot, this should be True)

# Parameters related to the waypoint follower
waypoint_follower:
  ros__parameters:
    use_sim_time: True # Whether to use the simulation time or not (on the simulated robot, this should be True)
    loop_rate: 20
    stop_on_failure: false
    waypoint_task_executor_plugin: "wait_at_waypoint"
    wait_at_waypoint:
      plugin: "nav2_waypoint_follower::WaitAtWaypoint"
      enabled: True
      waypoint_pause_duration: 200

# Parameters related to the velocity smoother
velocity_smoother:
  ros__parameters:
    use_sim_time: True # Whether to use the simulation time or not (on the simulated robot, this should be True)
    smoothing_frequency: 20.0
    scale_velocities: False
    feedback: "OPEN_LOOP"
    max_velocity: [0.26, 0.0, 1.0]
    min_velocity: [-0.26, 0.0, -1.0]
    max_accel: [1.0, 0.0, 0.5]
    max_decel: [-1.0, 0.0, -0.5]
    odom_topic: "odom"
    odom_duration: 0.1
    deadband_velocity: [0.0, 0.0, 0.0]
    velocity_timeout: 1.0
